<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<wsdl:definitions xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:mature="http://mature-ip.eu/MATURE" xmlns:t="http://mature-ip.eu/MATURE/types" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" name="MATURE" targetNamespace="http://mature-ip.eu/MATURE">
  <wsdl:types>
    <xsd:schema targetNamespace="http://mature-ip.eu/MATURE">
	<xsd:import namespace="http://mature-ip.eu/MATURE/types" schemaLocation="MATURE-types.xsd"/>	
      <xsd:element name="getPersonURIForEmailRequest">
      	<xsd:complexType>
      		<xsd:sequence>
      			<xsd:element name="emailAddress" type="xsd:string" maxOccurs="1" minOccurs="1"></xsd:element>
      			<xsd:element name="agentKey" type="xsd:string" maxOccurs="1" minOccurs="1"></xsd:element>
      			<xsd:element name="agentURI" type="xsd:string" maxOccurs="1" minOccurs="1">
      				<xsd:annotation>
      					<xsd:documentation>expected format:

mailto:user@example.com</xsd:documentation></xsd:annotation></xsd:element>
      		</xsd:sequence>
      	</xsd:complexType>
      </xsd:element>
      <xsd:element name="getPersonURIForEmailResponse">
      	<xsd:complexType>
      		<xsd:sequence>
      			<xsd:element name="personURI" type="xsd:string"></xsd:element>
      		</xsd:sequence>
      	</xsd:complexType>
      </xsd:element>

      <xsd:element name="createPersonRequest">
      	<xsd:complexType>
      		<xsd:sequence>

      			<xsd:element name="emailAddress" type="xsd:string"
      				maxOccurs="1" minOccurs="1">
                            <xsd:annotation>
                            	<xsd:documentation>the email address of the person to be created (only email address as string, not as URI with mailto-prefix)</xsd:documentation>
                            </xsd:annotation>
      			</xsd:element>
      			<xsd:element name="firstname" type="xsd:string"
      				maxOccurs="1" minOccurs="1">
                            <xsd:annotation>
                            	<xsd:documentation>the firstname of the person to be created</xsd:documentation>
                            </xsd:annotation>
      			</xsd:element>
      			<xsd:element name="lastname" type="xsd:string" maxOccurs="1" minOccurs="1">
      				<xsd:annotation>
      					<xsd:documentation>the lastname of the person to be created</xsd:documentation>
      				</xsd:annotation></xsd:element>
      			<xsd:element name="agentKey" type="xsd:string"
      				maxOccurs="1" minOccurs="1">
                            <xsd:annotation>
                            	<xsd:documentation>key of the agent who sends the request
</xsd:documentation>
                            </xsd:annotation>
      			</xsd:element>
      			<xsd:element name="agentURI" type="xsd:string"
      				maxOccurs="1" minOccurs="1">
                            <xsd:annotation>
                            	<xsd:documentation>uri of the agent who sends the request (its email address as URI with mailto-prefix)</xsd:documentation>
                            </xsd:annotation>
      			</xsd:element>
      		</xsd:sequence>
      	</xsd:complexType>
      </xsd:element>
      <xsd:element name="createPersonResponse">
      	<xsd:complexType>
      		<xsd:sequence>

      			<xsd:element name="success" type="xsd:boolean" maxOccurs="1" minOccurs="1">
      				<xsd:annotation>
      					<xsd:documentation>returns boolean that indicates if the creation of the person was successful or not</xsd:documentation>
      				</xsd:annotation></xsd:element>
      		</xsd:sequence>
      	</xsd:complexType>
      </xsd:element>
      <xsd:element name="getAllPersonsRequest">
      	<xsd:complexType>
      		<xsd:sequence>

      			<xsd:element name="agentKey" type="xsd:string"
      				maxOccurs="1" minOccurs="1">
                            <xsd:annotation>
                            	<xsd:documentation>key of the agent that sends the request</xsd:documentation>
                            </xsd:annotation>
      			</xsd:element>
      			<xsd:element name="agentURI" type="xsd:string" maxOccurs="1" minOccurs="1">
      				<xsd:annotation>
      					<xsd:documentation>uri of the agent who sends the request (its email address as URI with mailto-prefix)</xsd:documentation></xsd:annotation></xsd:element>
      		</xsd:sequence>
      	</xsd:complexType>
      </xsd:element>
      <xsd:element name="getAllPersonsResponse">
      	<xsd:complexType>
      		<xsd:sequence>

      			<xsd:element name="getAllPersonsResult" type="t:searchPersonEntry" maxOccurs="unbounded" minOccurs="0">
      				<xsd:annotation>
      					<xsd:documentation>list of all persons in the system</xsd:documentation>
      				</xsd:annotation></xsd:element>
      		</xsd:sequence>
      	</xsd:complexType>
      </xsd:element>
    
      <xsd:complexType name="personEntry">
                <xsd:annotation>
                	<xsd:documentation>represents one person in the list with personURI  (mailto:emailAddress) and name</xsd:documentation>
                </xsd:annotation>
                <xsd:sequence>
      		<xsd:element name="personURI" type="xsd:string"
      			maxOccurs="1" minOccurs="1">
                        <xsd:annotation>
                        	<xsd:documentation>URI of the person; i.e. mailto:emailAdress (e.g. mailto:test@mature-ip.eu)
</xsd:documentation>
                        </xsd:annotation>
      		</xsd:element>
      		<xsd:element name="name" type="xsd:string" maxOccurs="1" minOccurs="1">
      			<xsd:annotation>
      				<xsd:documentation>name of the person</xsd:documentation>
      			</xsd:annotation></xsd:element>
      	</xsd:sequence>
      </xsd:complexType>
    </xsd:schema>
  </wsdl:types>
  <wsdl:message name="getPersonURIForEmailRequest">
  	<wsdl:part name="parameters" element="mature:getPersonURIForEmailRequest"></wsdl:part>
  </wsdl:message>
  <wsdl:message name="getPersonURIForEmailResponse">
  	<wsdl:part name="parameters" element="mature:getPersonURIForEmailResponse"></wsdl:part>
  </wsdl:message>
    <wsdl:message name="invalidKeyException">
  	<wsdl:part name="parameters" element="t:invalidKeyMsg"></wsdl:part>
  </wsdl:message>
 
    <wsdl:message name="createPersonRequest">
    	<wsdl:part name="parameters" element="mature:createPersonRequest"></wsdl:part>
    </wsdl:message>
    <wsdl:message name="createPersonResponse">
    	<wsdl:part name="parameters" element="mature:createPersonResponse"></wsdl:part>
    </wsdl:message>
    <wsdl:message name="getAllPersonsRequest">
    	<wsdl:part name="parameters" element="mature:getAllPersonsRequest"></wsdl:part>
    </wsdl:message>
    <wsdl:message name="getAllPersonsResponse">
    	<wsdl:part name="parameters" element="mature:getAllPersonsResponse"></wsdl:part>
    </wsdl:message>
    <wsdl:portType  name="MATURE-PersonService">
	 <wsdl:operation name="getPersonURIForEmail">
    	<wsdl:input message="mature:getPersonURIForEmailRequest"></wsdl:input>
    	<wsdl:output message="mature:getPersonURIForEmailResponse"></wsdl:output>
            <wsdl:fault name="faultKey" message="mature:invalidKeyException"></wsdl:fault>
        </wsdl:operation>
	 <wsdl:operation name="createPerson">
	 	<wsdl:documentation>create a new Person, i.e. Resource, that can be tagge</wsdl:documentation>
	 	<wsdl:input message="mature:createPersonRequest"></wsdl:input>
	 	<wsdl:output message="mature:createPersonResponse"></wsdl:output>
            <wsdl:fault name="faultKey" message="mature:invalidKeyException"></wsdl:fault>
        </wsdl:operation>
	 <wsdl:operation name="getAllPersons">
	 	<wsdl:documentation>gives backa list of all persons (i.e. as resource) in the system; person might be tagged or no</wsdl:documentation>
	 	<wsdl:input message="mature:getAllPersonsRequest"></wsdl:input>
	 	<wsdl:output message="mature:getAllPersonsResponse"></wsdl:output>
            <wsdl:fault name="faultKey" message="mature:invalidKeyException"></wsdl:fault>
        </wsdl:operation>
    </wsdl:portType>

    <wsdl:binding name="MATUREPersonSOAP"
    	type="mature:MATURE-PersonService">

    	<soap:binding style="document"
    		transport="http://schemas.xmlsoap.org/soap/http" />
    	<wsdl:operation name="getPersonURIForEmail">

    		<soap:operation
    			soapAction="http://mature-ip.eu/MATURE/getPersonURIForEmail" />
    		<wsdl:input>

    			<soap:body use="literal" />
    		</wsdl:input>
    		<wsdl:output>

    			<soap:body use="literal" />
    		</wsdl:output>
    		<wsdl:fault name="faultKey">

    			<soap:fault use="literal" name="faultKey" />
    		</wsdl:fault>
    	</wsdl:operation>
    	<wsdl:operation name="createPerson">

    		<soap:operation
    			soapAction="http://mature-ip.eu/MATURE/createPerson" />
    		<wsdl:input>

    			<soap:body use="literal" />
    		</wsdl:input>
    		<wsdl:output>

    			<soap:body use="literal" />
    		</wsdl:output>
    		<wsdl:fault name="faultKey">

    			<soap:fault use="literal" name="faultKey" />
    		</wsdl:fault>
    	</wsdl:operation>
    	<wsdl:operation name="getAllPersons">

    		<soap:operation
    			soapAction="http://mature-ip.eu/MATURE/getAllPersons" />
    		<wsdl:input>

    			<soap:body use="literal" />
    		</wsdl:input>
    		<wsdl:output>

    			<soap:body use="literal" />
    		</wsdl:output>
    		<wsdl:fault name="faultKey">

    			<soap:fault use="literal" name="faultKey" />
    		</wsdl:fault>
    	</wsdl:operation>
    </wsdl:binding>

    <wsdl:service name="MATURE-PersonService">        <wsdl:port name="person" binding="mature:MATUREPersonSOAP">    	<soap:address location="http://mature-ip.eu/" /></wsdl:port>        </wsdl:service>
</wsdl:definitions>
